#!/usr/bin/python-init -Otu
#
# Copyright (C) 2008 Andreas Lang-Nevyjel
#
# Send feedback to: <lang-nevyjel@init.at>
#
# This file is part of python-modules-rrd
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License Version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
""" rrdtool dumper and merger """

import optparse
import os
import re
import sys
import tarfile
import cPickle
import pprint
import mail_tools
import time
import commands
import rrdtool
import pprint
import configfile
import bz2
import tempfile
import logging_tools
import process_tools
import pwd
import rrd_tools

class my_opt_parser(optparse.OptionParser):
    def __init__(self):
        optparse.OptionParser.__init__(self)
        self.add_option("--src", dest="source_files", help="files to read", default=[], action="append")
        self.add_option("--dst", dest="dest_file", help="file to write", default="XXX")
    def parse(self):
        options, args = self.parse_args()
        if args:
            print "Additional arguments found, exiting"
            sys.exit(0)
        self.options = options

def main():
    g_config = configfile.configuration("wri", {"LOG_NAME"        : configfile.str_c_var("rrddump"),
                                                "LOG_DESTINATION" : configfile.str_c_var("uds:/var/lib/logging-server/py_log")})
    my_parser = my_opt_parser()
    my_parser.parse()
    main_file = None
    for file_name in my_parser.options.source_files:
        act_file = rrd_tools.rrd_rra({"PERM_FIX" : False}, source_file=file_name, ignore_slot_mismatch=True)
        if main_file:
            for src_rra in main_file["rra_list"]:
                dst_rra = act_file.find_best_match(src_rra, default_cf="AVERAGE")
                if not src_rra:
                    print "*** no matching dst_rra found for %s" % (src_rra)
                else:
                    print "using dst_rra %-26s for src_rra %-26s" % (dst_rra,
                                                                     src_rra)
                    main_file.copy_rra_object(act_file, src_rra, dst_rra, 0, time.time(), overwrite_if_unknown=True)
        else:
            main_file = act_file
    main_file.write_rra(my_parser.options.dest_file, False)

if __name__ == "__main__":
    main()
